<?php

$xw = new xmlWriter();

function FilezillaConfigDL($file) {
	$name = 'sitemanager.xml';
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Content-type: application/force-download");
	header('Pragma: public');
	header("Pragma: no-cache");
	header('Last-Modified: '.gmdate('D, d M Y H:i:s') . ' GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');
	header('Cache-Control: pre-check=0, post-check=0, max-age=0');
	header('Content-Transfer-Encoding: none');
	header('Content-Type: application/octet-stream; name="'.$name.'"');
	header('Content-Type: application/octetstream; name="'.$name.'"');
	header('Content-Type: application/download; name="'.$name.'"');
	header('Content-Disposition: attachment; filename="'.$name.'"');
	header("Content-Description: File Transfer");
	echo FilezillaConfig($file);
}

function FilezillaConfig($file) {
	global $xw;
	
	$src = simplexml_load_file($file);

	$xw->openMemory();
	$xw->startDocument('1.0','UTF-8', 'yes');

	$xw->startElement('FileZilla3');
		$xw->startElement('Servers');

		$sites = $src->Sites[0];
		foreach($sites as $s)
			parseFolder($s);

		$xw->endElement();
	$xw->endElement();
	return $xw->outputMemory();
}

function eltIfNeed($name, $val) {
	if (strlen($val) > 0) {
		global $xw;
		$xw->startElement($name);
			$xw->text($val);
		$xw->endElement();
	}
}

function parseFolder(&$node) {
	global $xw;
	if ($node->getName() == 'Folder') {
		$xw->startElement('Folder');
		$xw->text($node['Name']);
		foreach($node->Folder as $f)
			parseFolder($f);
		foreach($node->Site as $s)
			parseSite($s);
		$xw->endElement();
	} else if ($node->getName() == 'Site') {
		parseSite($node);
	}
}
function parseSite(&$node) {
	global $xw;
	$pasvMode = Array();
	$pasvMode[0] = 'MODE_DEFAULT';
	$pasvMode[1] = 'MODE_PASSIVE';
	$pasvMode[2] = 'MODE_ACTIVE';
	$xw->startElement('Server');
	$xw->text($node['Name']);
		eltIfNeed('Host', $node['Host']);
		eltIfNeed('Port', $node['Port']);
		
		$serverType = $node['ServerType'];
		if ($serverType == 1)
			$serverType == 3;
		else if($serverType == 2 || $serverType == 4)
			$serverType = 4;
		else if($serverType == 3)
			$serverType = 1;
		eltIfNeed('Protocol', $serverType);
		
		if ($node['Logontype'] == 2)
			$logonType = 4;
		else if ($node['DontSavePass'] == 1)
			$logonType = 2;
		else
			$logonType = $node['Logontype'];
		eltIfNeed('Logontype', $logonType);
		
		eltIfNeed('User', $node['User']);
		if (!empty($node['Pass']))
			eltIfNeed('Pass', filezillaPasswordDecode($node['Pass']));
		eltIfNeed('Account', $node['Account']);
		eltIfNeed('TimezoneOffset', $node['TimeZoneOffset']*60 + $node['TimeZoneOffsetMinutes']);
		eltIfNeed('PasvMode', $pasvMode[intval($node['PasvMode'])]);
		
		$encoding = 'Auto';
		if ($node['UTF8'] == 1)
			$encoding = 'UTF-8';
		eltIfNeed('EncodingType', $encoding);
		
		eltIfNeed('Comments', $node['Comments']);
		eltIfNeed('LocalDir', $node['LocalDir']);
		if (strlen($node['RemoteDir']) > 0) {
			$rem = explode('/', $node['RemoteDir']);
			array_shift($rem);
			array_pop($rem);
			array_walk($rem, create_function('&$v','$v = trim($v); $v = " ".strlen($v)." ".$v;'));
			$remoteDir = '1 0'.implode('', $rem);
			eltIfNeed('RemoteDir', $remoteDir);
		}
	$xw->endElement();
}
function filezillaPasswordDecode($e) {
	$m = 'FILEZILLA1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	$e_len = strlen($e);
	$m_len = strlen($m);
	$offset = ($e_len / 3) % $m_len;
	$d = '';
	for ($i = 0; $i < $e_len; $i += 3) {
		$act = intval(substr($e, $i, 3));
		$k = ord($m{($offset + $i / 3) % $m_len});
		$d .= chr($act ^ $k);
	}
	return $d;
}
?>